import { createElement } from 'react';
import { render } from 'react-dom';
import { v1 } from 'uuid';
import MUIDataTable from 'mui-datatables';
import { Component, Input, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MuiDatatablesComponent {
    /**
     * @protected
     * @return {?}
     */
    getRootDomNode() {
        /** @type {?} */
        const node = document.getElementById(this.rootDomID);
        return node;
    }
    /**
     * @protected
     * @return {?}
     */
    getProps() {
        const { title, columns, data, options } = this;
        return {
            title,
            columns,
            data,
            options
        };
    }
    /**
     * @private
     * @return {?}
     */
    isMounted() {
        return !!this.rootDomID;
    }
    /**
     * @protected
     * @return {?}
     */
    render() {
        if (this.isMounted()) {
            render(createElement(MUIDataTable, this.getProps()), this.getRootDomNode());
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.rootDomID = v1();
    }
    /**
     * @return {?}
     */
    ngOnChanges() {
        this.render();
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.render();
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        // Uncomment if Angular 4 issue that ngOnDestroy is called AFTER DOM node removal is resolved
        // ReactDOM.unmountComponentAtNode(this.getRootDomNode())
    }
}
MuiDatatablesComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-mui-datatable',
                template: '<span [id]="rootDomID"></span>'
            }] }
];
MuiDatatablesComponent.propDecorators = {
    title: [{ type: Input }],
    columns: [{ type: Input }],
    data: [{ type: Input }],
    options: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxMuiDatatablesModule {
}
NgxMuiDatatablesModule.decorators = [
    { type: NgModule, args: [{
                declarations: [MuiDatatablesComponent],
                imports: [],
                exports: [MuiDatatablesComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { MuiDatatablesComponent, NgxMuiDatatablesModule };

//# sourceMappingURL=ngx-mui-datatables.js.map